<?php

if (!function_exists('master_addon_categories')):

    function master_addon_categories($elements_manager)

    {


        \Elementor\Plugin::$instance->elements_manager->add_category(

            'master-addons',

            [

                'title' => __('Master Elements ADDONS', 'masterelements'),

                'icon' => 'fa fa-plug',

            ]

        );

    }

endif;

if (!function_exists('master_init_widgets')):

    function master_init_widgets()
    {

        $widgets = register_addons_list();

        $aclass = new \MasterElements\Modules\Theme_Builder\Master_Custom_Post();

        $active_addons = $aclass->get_main_settings_data();

        foreach ($widgets as $widget) {


            if (isset($active_addons[$widget['id']]['name']) && $active_addons[$widget['id']]['value'] != 'no') {


                if ($active_addons[$widget['id']]['value'] == 'yes') {

                    if (is_array($widget['item'])) {

                        foreach ($widget['item'] as $wid) {

                            require_once \MasterElements::widgets_dir() . $wid['item'] . '/' . $wid['item'] . '.php';

                            $class_name = '\Elementor\\' . \MasterElements\Classes\Utils::make_classname('Master_' . $wid['item']);

                            \Elementor\Plugin::instance()->widgets_manager->register_widget_type(new $class_name());
                        }

                    } else {

                        require_once \MasterElements::widgets_dir() . $widget['item'] . '/' . $widget['item'] . '.php';

                        $class_name = '\Elementor\\' . \MasterElements\Classes\Utils::make_classname('Master_' . $widget['item']);

                        \Elementor\Plugin::instance()->widgets_manager->register_widget_type(new $class_name());

                    }


                }

            }

        }

    }

endif;

function register_addons_list()
{

    return $widgets = [
        'site-logo' => [

            'name' => 'Site Logo',

            'id' => 'me_site_logo',

            'item' => 'site-logo',

        ],

        'site-title' => [

            'name' => 'Site Title',

            'id' => 'me_site_title',

            'item' => 'site-title',

        ],

        'site-navigation' => [

            'name' => 'Site Navigation',

            'id' => 'site_navigation',

            'item' => 'navigation',

        ],

        'site-vertical-menu' => [

            'name' => 'Site Vertical Menu',

            'id' => 'site_vertical_menu',

            'item' => 'vertical-menu',

        ],

        'site-google-map' => [

            'name' => 'Site Google Map',

            'id' => 'site_google_map',

            'item' => 'google-map',

        ],
        'custom-posts' => [

            'name' => 'Blog Post',

            'id' => 'me_blog_post',

            'item' => 'blog-post',

        ],
        'breadcrumbs' => [

            'name' => 'Master Breadcrumbs',

            'id' => 'me_breadcrumbs',

            'item' => 'breadcrumbs',

        ],
        'team-member' => [

            'name' => 'Master Team Member',

            'id' => 'me_team_member',

            'item' => 'team-member',

        ],
        'me-forms' => [

            'name' => 'Master Forms',

            'id' => 'me_forms',

            'item' => 'me-forms',

        ],
        'float-effects' => [

            'name' => 'Float Effects',

            'id' => 'me_effects',

            'item' => 'me-effects',

        ],
        'custom-css' => [

            'name' => 'Master Custom Css',

            'id' => 'me_custom_css',

            'item' => 'custom-css',
        ],
        'me-table' => [

            'name' => 'Master Table',

            'id' => 'me_table',

            'item' => 'me-table',
        ],

        'master-woo-products' => [

            'name' => 'Master Woo Products',

            'id' => 'me_woo_products',

            'item' => array(

                'woo-product-title' => [

                    'name' => 'MW: Product Title',

                    'id' => 'me_woo_product_title',

                    'item' => 'woo-product-title',
                ],

                'woo-product-image' => [

                    'name' => 'Woo Product Image',

                    'id' => 'me_woo_product_image',

                    'item' => 'woo-product-image',
                ],

                'woo-product-rating' => [

                    'name' => 'Woo Product Rating',

                    'id' => 'me_woo_product_rating',

                    'item' => 'woo-product-rating',
                ],


                'woo-product-price' => [

                    'name' => 'Woo Product Price',

                    'id' => 'me_woo_product_price',

                    'item' => 'woo-product-price',
                ],


                'woo-product-description' => [

                    'name' => 'Woo Product Description',

                    'id' => 'me_woo_product_description',

                    'item' => 'woo-product-description',
                ],

                'woo-product-summary' => [

                    'name' => 'MW: Product Summary',

                    'id' => 'me_woo_product_summary',

                    'item' => 'woo-product-summary',
                ],


                'woo-product-meta' => [

                    'name' => 'Woo Product Meta',

                    'id' => 'me_woo_product_meta',

                    'item' => 'woo-product-meta',
                ],

                'woo-product-reviews' => [

                    'name' => 'Woo Product Reviews',

                    'id' => 'me_woo_product_reviews',

                    'item' => 'woo-product-reviews',
                ],

                'woo-add-to-cart' => [

                    'name' => 'Woo Add To Cart Button',

                    'id' => 'me_woo_add_to_cart',

                    'item' => 'woo-add-to-cart',
                ],

                'woo-related-products' => [

                    'name' => 'MW: Related Products',

                    'id' => 'me_woo_related_products',

                    'item' => 'woo-related-products',
                ],

                'woo-products-data-tabs' => [

                    'name' => 'MW: Products Data Tabs',

                    'id' => 'me_woo_products_data_tabs',

                    'item' => 'woo-products-data-tabs',
                ],

                'woo-next-prev-button' => [

                    'name' => 'MW: Single Product Pagination',

                    'id' => 'me_woo_next_prev_button',

                    'item' => 'woo-next-prev-button',
                ],

                'woo-product-archive' => [

                    'name' => 'MW: Archive Products',

                    'id' => 'me_woo_product_archive',

                    'item' => 'woo-product-archive',

                ],

                'woo-product-stock' => [

                    'name' => 'MW: Product Stock',

                    'id' => 'me_woo_product_stock',

                    'item' => 'woo-product-stock',
                ],

                'woo-product-comments' => [

                    'name' => 'MW: Product Comments',

                    'id' => 'me_woo_product_comments',

                    'item' => 'woo-product-comments',
                ],

                'woo-product-search' => [

                    'name' => 'MW: Product Search',

                    'id' => 'me_woo_product_search',

                    'item' => 'woo-product-search',
                ],

                'woo-cart-table' => [


                    'name' => 'MW: Cart Table',

                    'id' => 'me_woo_cart_table',


                    'item' => 'woo-cart-table',

                ],

                'woo-cart-total' => [


                    'name' => 'MW: Cart Total',


                    'id' => 'me_woo_cart_total',


                    'item' => 'woo-cart-total',

                ],

                'woo-shop-order-review' => [


                    'name' => 'MW: Shop Order Review',


                    'id' => 'me_woo_shop_order_review',


                    'item' => 'woo-shop-order-review',

                ],

                'woo-checkout-billing' => [


                    'name' => 'MW: Checkout Billing',


                    'id' => 'me_woo_checkout_billing',


                    'item' => 'woo-checkout-billing',

                ],
                'woo-checkout-shipping' => [


                    'name' => 'MW: Checkout Shipping Form',


                    'id' => 'me_woo_checkout_shipping',


                    'item' => 'woo-checkout-shipping',

                ],
                'woo-checkout-additional-info' => [

                    'name' => 'MW: Checkout Additional Form',

                    'id' => 'me_woo_checkout_additional_info',

                    'item' => 'woo-checkout-additional-info',

                ],
                'woo-checkout-payment' => [

                    'name' => 'MW: Checkout Payment',

                    'id' => 'me_woo_checkout_payment',

                    'item' => 'woo-checkout-payment',

                ],
                'woo-my-account-edit' => [


                    'name' => 'MW: My Account Edit',


                    'id' => 'me_woo_my_account_edit',


                    'item' => 'woo-my-account-edit',

                ],
                'woo-my-account-login' => [


                    'name' => 'MW: My Account Login Form',


                    'id' => 'me_woo_my_account_login',


                    'item' => 'woo-my-account-login',

                ],
                'woo-my-account-register' => [


                    'name' => 'MW: My Account Register Form',


                    'id' => 'me_woo_my_account_register',


                    'item' => 'woo-my-account-register',

                ],
                'woo-thankyou-order' => [


                    'name' => 'MW: Thankyou Order',


                    'id' => 'me_woo_thankyou_order',


                    'item' => 'woo-thankyou-order',

                ],
                'woo-thankyou-order-details' => [


                    'name' => 'MW: Thankyou Order Details',


                    'id' => 'me_woo_thankyou_order_details',


                    'item' => 'woo-thankyou-order-details',

                ],
                'woo-thankyou-address' => [


                    'name' => 'MW: Thankyou Customer Address',


                    'id' => 'me_woo_thankyou_address',


                    'item' => 'woo-thankyou-address',

                ],


            ),
        ],
        'post-title' => [

            'name' => 'Post Title',

            'id' => 'me_post_title',

            'item' => 'post-title',

        ],

        'post-image' => [

            'name' => 'Post Image',

            'id' => 'me_post_image',

            'item' => 'post-image',
        ],

        'post-content' => [

            'name' => 'Post Content',

            'id' => 'me_post_content',

            'item' => 'post-content',

        ],

        'post-author-image' => [

            'name' => 'Post Author Image',

            'id' => 'me_post_author_image',

            'item' => 'post-author-image',

        ],
        'post-meta' => [

            'name' => 'Post Meta',

            'id' => 'me_post_meta',

            'item' => 'post-meta',
        ],


        //        'call-of-action'=>[
//
//            'name'=>'Call of Action',
//
//            'id'=>'me_call_of_action',
//
//            'item'=>'call-of-action',
//
//        ],
//
//        'accordion'=>[
//
//            'name'=>'Accordion',
//
//            'id'=>'me_accordion',
//
//            'item'=>'accordion',
//
//        ],
//
//        'heading'=>[
//
//            'name'=>'Heading',
//
//            'id'=>'me_heading',
//
//            'item'=>'heading',
//
//        ],
//
//        'info-box'=>[
//
//            'name'=>'Info Box',
//
//            'id'=>'me_info_box',
//
//            'item'=>'info-box',
//
//        ],
//
//        'icon-box'=>[
//
//            'name'=>'Icon Box',
//
//            'id'=>'me_icon_box',
//
//            'item'=>'icon-box',
//
//        ],
//
//        'countdown'=>[
//
//            'name'=>'Countdown',
//
//            'id'=>'me_countdown',
//
//            'item'=>'countdown',
//
//        ],
//
//
//        'search'=>[
//
//            'name'=>'Search',
//
//            'id'=>'me_search',
//
//            'item'=>'search',
//
//        ],
//

//
    ];

}