<?php

namespace Elementor;

use \Elementor\Controls_Manager;



if ( ! defined( 'ABSPATH' ) ) exit;

class Master_Post_Content extends Widget_Base {

	public $base;

    public function get_name() {

		//get name from postcontent-handler file

		return 'postcontent';

    }

    public function get_title() {

		//get title from postcontent-handler file

		return esc_html__( 'Master Post Content', 'masterelements' );

    }

    public function get_icon() {

		//get icon from postcontent-handler file

		return 'post-content';

    }

    public function get_categories() {

		//get categories from postcontent-handler file

        return [ 'master-addons' ];

	}

	//default elementor function to register and build controls

    protected function _register_controls() {

		//single post content section

        $this->start_controls_section(

			'content_section',

			[

				'label' => __( 'Master Single Post Content', 'masterelements' ),

				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,

			]

		);

		//text align control inside single post content section

        $this->add_control(

			'title_align',

			[

				'label' => __( 'Alignment', 'masterelements' ),

				'type' => Controls_Manager::CHOOSE,

				'options' => [

					'left' => [

						'title' => __( 'Left', 'masterelements' ),

						'icon' => 'fa fa-align-left',

					],

					'center' => [

						'title' => __( 'Center', 'masterelements' ),

						'icon' => 'fa fa-align-center',

					],

					'right' => [

						'title' => __( 'Right', 'masterelements' ),

						'icon' => 'fa fa-align-right',

					],

					'right' => [

						'title' => __( 'Right', 'masterelements' ),

						'icon' => 'fa fa-align-right',

					],

				],

				'default' => 'left',

				'selectors' => [

					'{{WRAPPER}} .post_content p' => 'text-align: {{VALUE}};',

				],

				'separator' => 'before',

			]

		);

		$this->end_controls_section(); //end first section

		//style section after single post content section.

        $this->start_controls_section(

			'style_section',

			[

				'label' => __( 'Style', 'masterelements' ),

				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,

			]

		);

		//typography control inside style section.

        $this->add_group_control(

			Group_Control_Typography::get_type(),

			[

				'name' => 'title_typography',

				'label' => __( 'Typography', 'masterelements' ),

				'scheme' => Scheme_Typography::TYPOGRAPHY_1,

				'selector' => '{{WRAPPER}} .post_content p', //adding this control to p tag having class .post_content in render function

			]

        );

         //Color picker control inside style section

         $this->add_control(

        	'title_color',

        	[

        		'label' => __( 'Title Color Text', 'masterelements' ),

        		'type' => Controls_Manager::COLOR,

        	'default' => '#000',

        		'selectors' => [

        			'{{WRAPPER}} .post_content p' => 'color: {{VALUE}}', //adding this control to p tag having class .post_content in render function

        		],

        	]

        );

        $this->end_controls_section();

	}

	//front end display

    protected function render() {

		//getting all the settings (control title)of every controls and section.


		$queried_object = get_queried_object();



		if ( $queried_object ) {

			//$post_id = $queried_object->ID;

			//echo $post_id;

		}

		//$post = get_post($post_id); // specific post

		//$the_content = apply_filters('the_content', $post->post_content);

		if ( !empty($the_content) ) {



			//echo '<div class="post_content">';

				// echo $the_content;

			//echo '</div>';


		}

		?>



		<?php



	}

}