<?php

/**
 * This Functions is Taken From WooCommerce
 */

use MasterElements\Master_Woocommerce_Functions;

defined('ABSPATH') || exit;

$mrp = new Master_Woocommerce_Functions();

$mrp::mw_add_action('woocommerce_before_cart'); ?>

    <form class="me-woocommerce-cart-form" action="<?php echo esc_url($mrp::mw_get_cart_url()); ?>" method="post">

        <?php $mrp::mw_add_action('woocommerce_before_cart_table'); ?>

        <table class="shop_table shop_table_responsive cart me-woocommerce-cart-form__contents" cellspacing="0">
            <thead>
            <tr>
                <th class="me-product-remove">&nbsp;</th>

                <th class="me-product-thumbnail">&nbsp;</th>

                <th class="me-product-name"><?php esc_html_e('Product', 'masterelements'); ?></th>

                <th class="me-product-price"><?php esc_html_e('Price', 'masterelements'); ?></th>

                <th class="me-product-quantity"><?php esc_html_e('Quantity', 'masterelements'); ?></th>

                <th class="me-product-subtotal"><?php esc_html_e('Total', 'masterelements'); ?></th>
            </tr>
            </thead>
            <tbody>
            <?php $mrp::mw_add_action('woocommerce_before_cart_contents'); ?>

            <?php
            foreach ($mrp::mw_wc_get_cart() as $me_item_key => $item_in_cart) {
                $me_product = apply_filters('woocommerce_cart_item_product', $item_in_cart['data'], $item_in_cart, $me_item_key);

                $me_product_id = apply_filters('woocommerce_cart_item_product_id', $item_in_cart['product_id'], $item_in_cart, $me_item_key);

                if ($me_product && $me_product->exists() && $item_in_cart['quantity'] > 0 && apply_filters('woocommerce_cart_item_visible', true, $item_in_cart, $me_item_key)) {

                    $product_permalink = apply_filters('woocommerce_cart_item_permalink', $me_product->is_visible() ? $me_product->get_permalink($item_in_cart) : '', $item_in_cart, $me_item_key);

                    ?>

                    <tr class="me-woocommerce-cart-form__cart-item <?php echo esc_attr(apply_filters('woocommerce_cart_item_class', 'cart_item', $item_in_cart, $me_item_key)); ?>">

                        <td class="me-product-remove">
                            <?php

                            echo apply_filters('woocommerce_cart_item_remove_link', sprintf(

                                '<a href="%s" class="remove" aria-label="%s" data-product_id="%s" data-product_sku="%s">&times;</a>',

                                esc_url($mrp::mw_get_cart_remove_url($me_item_key)),

                                esc_html__('Remove this item', 'masterelements'),

                                esc_attr($me_product_id),

                                esc_attr($mrp::mw_get_sku($me_product))

                            ), $me_item_key);
                            ?>
                        </td>

                        <td class="me-product-thumbnail">
                            <?php

                            $thumbnail = apply_filters('woocommerce_cart_item_thumbnail', $mrp::mw_get_image($me_product), $item_in_cart, $me_item_key);

                            if (!$product_permalink) {

                                echo($thumbnail);

                            } else {

                                printf('<a href="%s">%s</a>', esc_url($product_permalink), $thumbnail);

                            }
                            ?>

                        </td>

                        <td class="me-product-name" data-title="<?php esc_attr_e('Product', 'masterelements'); ?>">

                            <?php

                            if (!$product_permalink) {

                                echo $mrp::mw_kses_post(apply_filters('woocommerce_cart_item_name', $mrp::mw_get_name($me_product), $item_in_cart, $me_item_key) . '&nbsp;');

                            } else {

                                echo $mrp::mw_kses_post(apply_filters('woocommerce_cart_item_name', sprintf('<a href="%s">%s</a>', esc_url($product_permalink), $mrp::mw_get_name($me_product)), $item_in_cart, $me_item_key));

                            }

                            do_action('woocommerce_after_cart_item_name', $item_in_cart, $me_item_key);


                            echo $mrp::mw_get_formatted_cart_item_data($item_in_cart);

                            if ($mrp::mw_backorders_require_notification($me_product) && $me_product->is_on_backorder($item_in_cart['quantity'])) {

                                echo $mrp::mw_kses_post(apply_filters('woocommerce_cart_item_backorder_notification', '<p class="backorder_notification">' . esc_html__('Available on backorder', 'masterelements') . '</p>', $me_product_id));

                            }
                            ?>

                        </td>

                        <td class="me-product-price" data-title="<?php esc_attr_e('Price', 'masterelements'); ?>">
                            <?php

                            echo apply_filters('woocommerce_cart_item_price', WC()->cart->get_product_price($me_product), $item_in_cart, $me_item_key);

                            ?>

                        </td>

                        <td class="me-product-quantity" data-title="<?php esc_attr_e('Quantity', 'masterelements'); ?>">

                            <?php

                            if ($mrp::mw_is_sold_individually($me_product)) {

                                $product_quantity = sprintf('1 <input type="hidden" name="cart[%s][qty]" value="1" />', $me_item_key);

                            } else {
                                $product_quantity = woocommerce_quantity_input(array(

                                    'input_name' => "cart[{$me_item_key}][qty]",

                                    'input_value' => $item_in_cart['quantity'],

                                    'max_value' => $mrp::mw_get_max_purchase_quantity($me_product),

                                    'min_value' => '0',

                                ), $me_product, false);

                            }

                            echo apply_filters('woocommerce_cart_item_quantity', $product_quantity, $me_item_key, $item_in_cart);

                            ?>

                        </td>

                        <td class="me-product-subtotal" data-title="<?php esc_attr_e('Total', 'masterelements'); ?>">
                            <?php

                            echo apply_filters('woocommerce_cart_item_subtotal', WC()->cart->get_product_subtotal($me_product, $item_in_cart['quantity']), $item_in_cart, $me_item_key);

                            ?>
                        </td>
                    </tr>
                    <?php
                }
            }
            ?>

            <?php $mrp::mw_add_action('woocommerce_cart_contents'); ?>

            <tr>
                <td colspan="6" class="actions">

                    <?php if (wc_coupons_enabled()) { ?>
                        <div class="coupon">

                            <label for="coupon_code"><?php esc_html_e('Coupon:', 'masterelements'); ?></label> <input
                                    type="text" name="coupon_code" class="input-text" id="coupon_code" value=""
                                    placeholder="<?php esc_attr_e('Coupon code', 'masterelements'); ?>"/> <input
                                    type="submit" class="button" name="apply_coupon"
                                    value="<?php esc_attr_e('Apply coupon', 'masterelements'); ?>"/>

                            <?php $mrp::mw_add_action('woocommerce_cart_coupon'); ?>

                        </div>
                    <?php } ?>

                    <input type="submit" class="button" name="update_cart"
                           value="<?php esc_attr_e('Update cart', 'masterelements'); ?>"/>

                    <?php $mrp::mw_add_action('woocommerce_cart_actions'); ?>

                    <?php wp_nonce_field('woocommerce-cart'); ?>
                </td>
            </tr>

            <?php $mrp::mw_add_action('woocommerce_after_cart_contents'); ?>
            </tbody>
        </table>
        <?php $mrp::mw_add_action('woocommerce_after_cart_table'); ?>
    </form>

<?php $mrp::mw_add_action('woocommerce_after_cart'); ?>